' Base V0.68 + CMM2 specific mods such as:
'   1) relocatable, resizeable, non-destructive 'popups'
'   2) vertical sliders (maybe will add ability for left/right pointing arrow, currently left only)
'   3) multiple simultaneous popup support planned as this develops.


'{mandatory GUI config
  Option Base 0
  mode 10,8
  on error ignore 'this to exit gracefully, closing mouse controller, see code in main loop.

  Const cGy=&hdddddd'Pale grey window background
  Const cGH=&h909090
  Const TRUE = 1
  Const FALSE = 0
  
  
  Dim Integer Wins=3,Objs=100,P=0,Flags,Xt,Yt,Xo,Yo,CMM2,lg=0,Ut,Vt,Wt,Zt,L
  Dim Integer O(Wins,Objs,10)'GUI object settings
  Dim String Ot(Objs) Length 64'GUI object text
 



  'CMM2 Compatibility - and any others if necessary
  Select Case MM.Device$
    Case "Colour Maximite 2"
      mp=MM.info(option mouse) ' mouse port 
      CMM2=TRUE
      Option Console Serial
      GUI CURSOR ON 0, 100,100,rgb(red)
      CONTROLLER MOUSE OPEN mp
    Case Else
      Ut = 0
      Vt = 0
  End Select
'}


if CMM2 then
  page write 0
  Colour RGB(NOTBLACK),RGB(YELLOW) 
  CLS
  Colour RGB(NOTBLACK),cGy

  window 1,200,200,340,260,TRUE
else
  Colour RGB(NOTBLACK),cGy:Cls
  Backlight 80' 100 is off
end if


 
MainInit:

  Dim Integer res

  res=GUIObjDef(80,9,0,0,Wt,Zt," Window ",,,&h04)
'Buttons
  res=GUIObjDef(21,1,10,10,80,30,"Save",,,1)
  res=GUIObjDef(23,1,10,50,80,30,"Exit",RGB(RED),RGB(WHITE),1)
'Checkboxes
  res=GUIObjDef(25,3,10,100,,,"Checked")
  res=GUIObjDef(27,3,10,120,,,"Disabled")
  res=GUIObjDef(29,3,10,140,,,"Not Checked")
'Radio boxes (in a frame)
  res=GUIObjDef(40,2,170,100,,,"Red",1,&hff0000)
  'res=GUIObjDef(40,2,170,100,,,"Red",1,0)
  res=GUIObjDef(41,2,170,120,,,"Green",1,&hff00)
  'res=GUIObjDef(41,2,170,120,,,"Green",1,0)
  res=GUIObjDef(42,2,170,140,,,"Blue",1,&hff)
  'res=GUIObjDef(42,2,170,140,,,"Blue",1,0)
  res=GUIObjDef(39,9,165,90,80,65,"Colours",,,&h05)
'text boxes
  res=GUIObjDef(50,5,160,10,150,15,"L Text black frame",&h00aa00,&hffff00,&h04)
  res=GUIObjDef(51,5,160,35,150,15,"C Text no frame",cGy,0,&h10)
  res=GUIObjDef(52,5,160,60,150,15,"",&hffffff,0,&h22)
'progress bar
  res=GUIObjDef(61,8,10,210,300,20,"",0,500,&h0000ff02)
  res=GUIObjDef(62,8,270,90,40,65,"",0,500,&hff000012)
'Sliders
  res=GUIObjDef(71,4,20,180,100,,"H",0,500,51)
  res=GUIObjDef(72,4,120,60,0,100,"V",0,500,50)

Main:
'set the properties of the object, visibility, enabled etc...
  res=GUIObjPSet(21,&b00001100)
'  res=GUIObjPSet(23,&b00001000)
  res=GUIObjPSet(23,&b00001100)
  res=GUIObjPSet(25,&b00101100)
  res=GUIObjPSet(27,&b00101000)
  res=GUIObjPSet(29,&b00001100)
  res=GUIObjPSet(39,&b00001100)
  res=GUIObjPSet(40,&b00101100)
  res=GUIObjPSet(41,&b00001100)
  res=GUIObjPSet(42,&b00001000)
  res=GUIObjPSet(50,&b00001100)
  res=GUIObjPSet(51,&b00001100)
  res=GUIObjPSet(52,&b00001100)
  res=GUIObjPSet(61,&b00001100)
  res=GUIObjPSet(62,&b00001100)

  res=GUIObjPSet(71,&b00001100)
  res=GUIObjPSet(72,&b00001100)

'nothing appears on the screen until you draw the object
'this allows multiple updates at once and you control when it happend
  GUIObjDraw 21
  GUIObjDraw 23
  GUIObjDraw 25
  GUIObjDraw 27
  GUIObjDraw 29
  GUIObjDraw 39
  GUIObjDraw 40
  GUIObjDraw 41
  GUIObjDraw 42
  GUIObjDraw 50
  GUIObjDraw 51
  GUIObjDraw 52
  GUIObjDraw 61
  GUIObjDraw 62

  GUIObjVSet 71,250
  GUIObjDraw 71
  GUIObjVSet 72,250
  GUIObjDraw 72

  GUIObjDraw 80


'a little example code
  q=1000
  If res <>-1 Then
    timer=0
'draw the progress bars for increasing value
    For n=1 To q step 25
        GUIObjVSet 61,n
        GUIObjDraw 61
        GUIObjVSet 62,n
        GUIObjDraw 62
       ' pause 200
    Next
'set the contents of a text box
    Ot(GUIObjFind(52))="R "+Str$(timer/n)+"mS"
    GUIObjDraw 52
  EndIf

'go round in a loop printing (to the console) the ID (numeric name) of
'any touched objects and how long it was touched for
  Do
    if mm.errno <> 0 then
      text 5,5,mm.errmsg$,,,,0,cGY
      text 5,20,"press a key to exit...",,,,0,cGY
      do while k$ = ""
        k$ = inkey$
      loop
      end
    end if
    Timer=0
    q=ProcessTouch()
    If q<>-1 Then ? "Obj ";q,,"Dwell";Timer;"mS"
    'get the value from the slider and update a text box
    IF Q = 23 THEN      'EXIT BUTTON PRESSED
      if CMM2 then
        window 1,200,200,320,240,FALSE
      end if
      end
    end if

    
    If q=71 Then
      For m=51 to 52
        if Ot(GUIObjFind(q))="V" then
          Ot(GUIObjFind(m))=Str$(o(1,GuiObjFind(71),8)-GUIObjVGet(71)):GUIObjDraw m
        else
          Ot(GUIObjFind(m))=Str$(GUIObjVGet(71)):GUIObjDraw m        
        end if
      Next
    EndIf

    if q=52 then      'get input into textbox
      GetInText q
    END IF  
  Loop

  End


sub GetInText obj as integer
  local N,ans$,ansr$,ansl$,k$,chrs
  local Ipt$ = "1234567890AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz :;<>@#$%^&*()~-+=[]{}\/|.,?!'"

      k$ = ""
      N = 0
      chrs = (o(1,GuiObjFind(obj),5)-o(1,GuiObjFind(obj),3))\8
      
      ans$ = Ot(GUIObjFind(obj))
      if len(ans$) > chrs then      
        Ot(GUIObjFind(obj))=right$(ans$,chrs)
      end if
      GUIObjDraw obj
      cursor obj,N
      do while k$ <> chr$(13)
        cursor obj,N
        text 5,5,str$(len(ans$)),,,,0,cGh
        k$ = inkey$                
        GetTouch          'read mouse 
        if k$ <> "" then
          if k$ = chr$(8) and len(ans$) >= 1 then
            if N = 0 then
              ans$ = left$(ans$,len(ans$)-1)
            else
              ansl$ = left$(ans$,len(ans$)-(N+1))
              ansr$ = right$(ans$,(N-0))
              ans$ = ansl$+ansr$
            end if              
          else if k$ = chr$(130) then 'cursor left
            if N < 18 then
              N = N+1
            end if
          else if k$ = chr$(131) then 'cursor right
            if N > 0 then
              N = N - 1
            end if
          else if instr(1,Ipt$+chr$(34),k$) <> 0 then
            if N = 0 then
              ans$ = ans$ + k$
            else 
              ansl$ = left$(ans$,len(ans$)-N)
              ansr$ = right$(ans$,N)
              ans$ = ansl$+k$+ansr$
            end if
          end if
          
          if len(ans$) <= chrs then
            Ot(GUIObjFind(obj))=ans$
          else
            Ot(GUIObjFind(obj))=right$(ans$,chrs)
          end if
          
          GUIObjDraw obj       
          pause 100
        end if
        if L then         'if left click then exit
          k$ = chr$(13)
        end if
        Ot(GUIObjFind(obj))=ans$
'        pause 50       
      loop
      blit write 63,o(1,GuiObjFind(obj),5)+Ut-cpos*8-8,o(1,GuiObjFind(obj),4)+Vt
end sub


sub cursor obj as integer, cpos as integer 
  static f = TRUE
  
  if f then
    blit read 63,o(1,GuiObjFind(q),5)+Ut-cpos*8-8,o(1,GuiObjFind(q),4)+Vt,9,12,0
    pause 50
    line o(1,GuiObjFind(q),5)+Ut-cpos*8,o(1,GuiObjFind(q),4)+Vt+2,o(1,GuiObjFind(q),5)+Ut-cpos*8,o(1,GuiObjFind(q),4)+Vt+11,,0
  else
    blit write 63,o(1,GuiObjFind(q),5)+Ut-cpos*8-8,o(1,GuiObjFind(q),4)+Vt
  end if
  pause 50
  f = not f
end sub
    

'------------------ The GUI pack
'Main touch processor. Regular calls here will get the numeric name of
'screen objects that are touched, return -1 if no object is touched
'animates and manages status etc
  Function ProcessTouch() As Integer
    ProcessTouch=-1
    GetTouch
    If Xt=-1 Then Exit Function
    Local Integer n,m
    For n=0 To P-1
      If Xt>=o(1,n,3)+Ut Then
        If Yt>=o(1,n,4)+Vt Then
          If Xt<=o(1,n,5)+Ut Then
            If Yt<=o(1,n,6)+Vt Then
              If o(1,n,2) And 8 Then
                If o(1,n,2) And 4 Then
                  ProcessTouch=o(1,n,0)
                  o(1,n,2)=o(1,n,2) Or &b00010000'touched
                  Select Case o(1,n,1)'click animation
                    Case 1
                      o(1,n,9)=2
                      GUIObjDraw o(1,n,0)
                    Case 2
                      For m=0 To P
                        If o(1,n,0)<>o(1,m,0) Then
                          If o(1,m,1)=2 Then
                            If o(1,m,7)=o(1,n,7) Then
                              o(1,m,2)=o(1,m,2) And &b11011111
                              GUIObjDraw o(1,m,0)
                            EndIf
                          EndIf
                        EndIf
                      Next
                      o(1,n,2)=o(1,n,2) Or &h20
                      GUIObjDraw o(1,n,0)
                    Case 3
                      If o(1,n,2) And &b00100000 Then
                        o(1,n,2)=o(1,n,2) And &b11011111
                      Else
                        o(1,n,2)=o(1,n,2) Or &b00100000
                      EndIf
                      GUIObjDraw o(1,n,0)
                    Case 4'slider
                      Local w
                      GUI Cursor Hide
                      Do
                        'Watchdog in here
                        GetTouch
                        if Ot(n) = "H" then
                          If Xt=-1 Then Exit Do
                          w=o(1,n,5)-o(1,n,3)
                          Xt=Constrain(Xt-(o(1,n,3)+Ut),0,w)'screen x to range of slider
                          w=Xt/(w/(o(1,n,8)-o(1,n,7)))
                          GUIObjVSet o(1,n,0),w
                          If o(1,n,9) Then 
                            Ot(GUIObjFind(o(1,n,9)))=Str$(w)
                            GUIObjDraw o(1,n,9)
                          EndIf
                        else
                          If Xt=-1 Then Exit Do
                          h=o(1,n,6)-o(1,n,4)
                          Yt=Constrain(Yt-(o(1,n,4)+Vt),0,h)'screen y to range of slider
                          h=Yt/(h/(o(1,n,8)-o(1,n,7)))
                          GUIObjVSet o(1,n,0),h
                          If o(1,n,9) Then 
                            Ot(GUIObjFind(o(1,n,9)))=Str$(o(1,n,8)-h)
                            GUIObjDraw o(1,n,9)
                          EndIf

                        end if
                        GUIObjDraw o(1,n,0)
                      Loop
                      GUI Cursor Show
                    Case 6
                    Case 7
                  End Select
                  WaitNoTouch
                  Select Case o(1,n,1)'release animation
                    Case 1
                      o(1,n,9)=1
                      GUIObjDraw o(1,n,0)
                    Case 6
                    Case 7
                  End Select
                  Exit Function
                EndIf
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
    Next
  End Function

'waits for the stylus to be lifted off the panel
  Sub WaitNoTouch
    If CMM2 Then
      Do
      'Watchdog here if you want it
      Pause 10
      Loop Until Mouse(L,mp)=0
    Else
      Do
      'Watchdog here if you want it
      Pause 10
      Loop Until Touch(X)=-1
    EndIf
  End Sub

'Sub will draw any object in it's current state
  Sub GuiObjDraw(id As Integer)'n is the object id
    Local Integer n,m,x,y,z,w,h,c,f
    Local Float nn
    Local a$
    n=GUIObjFind(id)
    If n>-1 Then
      GUIObjCleanup n
      x=o(1,n,3)+Ut:y=o(1,n,4)+Vt
      w=o(1,n,5)-x+Ut:h=o(1,n,6)-y+Vt
      Select Case o(1,n,1)
        Case 1'button
          If o(1,n,2) And 8 Then'visible
            box x,y,w,h,,o(1,n,7),o(1,n,7)
            GUIFrame n,0
            If o(1,n,2) And 4 Then'Enabled
              z=o(1,n,8)
            Else'ghosted
              z=cGH
            EndIf
            Text w/2+x-FONTWIDTH()*Len(Ot(n))/2,h/2+y-FONTHEIGHT()/2,Ot(n),,,,z,o(1,n,7)
          Else'disappear
            GUIObjCleanup n,1
          EndIf
        Case 2'radio
          If o(1,n,2) And 8 Then'visible
            x=x+5:y=y+5
            If o(1,n,2) And 4 Then'Enabled
              If o(1,n,2) And 32 Then'set
                Circle x,y,4,,,o(1,n,8),o(1,n,8)
                Colour RGB(NOTBLACK)
                For nn=2.34 To 5.5 Step 0.2
                  Pixel x+6*Sin(nn),y+6*Cos(nn)
                Next
                Colour &hffffff
                For nn=5.5 To 8.64 Step 0.2
                  Pixel x+6*Sin(nn),y+6*Cos(nn)
                Next
              Else
                Circle x,y,4,,,CGy,CGy
                Colour &hffffff
                For nn=2.34 To 5.5 Step 0.2
                  Pixel x+6*Sin(nn),y+6*Cos(nn)
                Next
                Colour RGB(NOTBLACK)
                For nn=5.5 To 8.64 Step 0.2
                  Pixel x+6*Sin(nn),y+6*Cos(nn)
                Next
              EndIf
              Colour RGB(NOTBLACK)
            Else
              Circle x,y,4,,,CGy,CGy
              color cGH
              For nn=0 To 6.4 Step 0.2
                Pixel x+6*Sin(nn),y+6*Cos(nn)
              Next
            EndIf
            Text x+15,y+(h/2)-FONTHEIGHT(),Ot(n)
          Else'disappear
            GUIObjCleanup n,1
          EndIf
        Case 3'checkbox
          If o(1,n,2) And 8 Then'visible
            Colour RGB(NOTBLACK)
            Line x,y,x,y+11'|
            Line x,y,x+11,y'-
            Colour &hffffff
            Line x+11,y,x+11,y+11'|
            Line x,y+11,x,y+11'_
            If o(1,n,2) And 4 Then'Enabled
              Colour RGB(NOTBLACK)
            Else'ghosted
              Colour Cgh
            EndIf
            If o(1,n,2) And 32 Then'checked
              GUI bitmap x+2,y+2,&h18386C6CC6020301
            Else
              GUI bitmap x+2,y+2,0
            EndIf
            Text x+15,y+(h/2)-(FONTHEIGHT()/2),Ot(n),,,,,CGy
          Else'disappear
            GUIObjCleanup n,1
          EndIf
        Case 4'slider

          If o(1,n,2) And 8 Then'visible
            if Ot(n) = "H" then
              Box x-5,y,w+11,h+1,,CGY,CGy
              y=y+(h/2)'centre line of slider
              Colour RGB(NOTBLACK)
              Line x,y-2,x+w,y-2'-
              Line x,y-2,x,y+2'|
              Colour &hffffff
              Line x,y+2,x+w,y+2'_
              Line x+w,y+2,x+w,y-2'|
              x=x+((w/(o(1,n,8)-o(1,n,7)))*o(1,n,10))'pointer position for
              'current value in pixels
              y=o(1,n,4)+Vt
            else             
              Box x,y-5,w+1,h+11,,CGY,CGY
              x=x+(w/2)'centre line of slider
              Colour RGB(NOTBLACK)
              Line x-2,y,x-2,y+h'|
              Line x-2,y,x+2,y'-
              Colour &hffffff
              Line x+2,y,x+2,y+h'_
              Line x+2,y+h,x-2,y+h'|
              y=y+((h/(o(1,n,8)-o(1,n,7)))*o(1,n,10))'pointer position for
              'current value in pixels
              x=o(1,n,3)+Ut
            
            end if

            'pointer
            If o(1,n,2) And 4 Then'Enabled
              if Ot(n) = "H" then
                Box x-5,y,11,h,,CGy,CGy
                Colour RGB(NOTBLACK)
                Line x+5,y+3,x+5,y+h'|
                Line x+5,y+h,x-5,y+h'_
                color cGH
                Line x,y,x+5,y+3'\
                Colour &hffffff
                Line x-5,y+h,x-5,y+3'|
                Line x-5,y+3,x,y'/
              else 'vertical
                Box x,y-5,w,11,,CGy,CGy
                Colour RGB(NOTBLACK)
                Line x+3,y+5,x+w,y+5'_
                Line x+w,y+5,x+w,y-5'|
                color cGH
                Line x,y,x+3,y+5'\
                Colour &hffffff
                Line x+3,y-5,x+w,y-5'|
                Line x,y,x+3,y-5'/              
                pause 35  'eliminates tearing artifacts
              end if
            Else  'disabled
              if Ot(n) = "H" then
                Box x-5,y,11,h,,CGY,CGy
                color cGH
                Line x+5,y+3,x+5,y+h'|
                Line x+5,y+h,x-5,y+h'_
                Line x,y,x+5,y+3'\
                Line x-5,y+h,x-5,y+3'|
                Line x-5,y+3,x,y'/
              else
                Box x,y-5,w,11,,CGy,CGy
                color cGH
                Line x+3,y+5,x+w,y+5'_
                Line x+w,y+5,x+w,y-5'|
                Line x,y,x+3,y+5'\
                Line x+3,y-5,x+w,y-5'|
                Line x,y,x+3,y-5'/                            
              end if
            EndIf
          Else'disappear
            GUIObjCleanup n,1
          EndIf
        Case 5'textbox
          If mm.hres > 960 then
            f=7
          else
            f=1
          end if            
          If o(1,n,2) And 8 Then'visible
            Box x,y,w+1,h+1,,o(1,n,7),o(1,n,7)
            GUIFrame n,1
            Select Case o(1,n,9)>>4
              Case 0'L
                Text x,y,Ot(n),,f,,o(1,n,8),o(1,n,7)
              Case 1'C
                Text w/2+x-FONTWIDTH()*Len(Ot(n))/2,h/2+y-FONTHEIGHT()/2,Ot(n),,f,,o(1,n,8),o(1,n,7)
              Case 2'R
                Text o(1,n,5)-(FONTWIDTH()*Len(Ot(n)))+Ut,h/2+y-FONTHEIGHT()/2,Ot(n),,f,,o(1,n,8),o(1,n,7)
            End Select
          Else'disappear
            GUIObjCleanup n,1
          EndIf
        Case 6'list static
        Case 7'list dropdown
        Case 8'progress bar
          If o(1,n,2) And 8 Then'visible
            GUIFrame n,1
            If o(1,n,9) And &h10 Then'vert
              z=(h/(o(1,n,8)-o(1,n,7)))*o(1,n,10)'pixels per increment*value = width of bar to draw in pixels
              Box x,y,w,h-z,,cGy,cGy
              Box x,(y+h)-z,w,z,,o(1,n,9)>>8,o(1,n,9)>>8
            Else'hoz
              z=(w/(o(1,n,8)-o(1,n,7)))*o(1,n,10)'pixels per increment*value = width of bar to draw in pixels
              Box x+z,y,w-z,h,,cGy,cGy
              Box x,y,z,h,,o(1,n,9)>>8,o(1,n,9)>>8
            EndIf
          Else'disappear
            GUIObjCleanup n,1
          EndIf
        Case 9'frame
          GUIFrame n,0
          Colour RGB(NOTBLACK),cGy
          Text x+5,y-FONTHEIGHT()/2,Ot(n)
      End Select
    EndIf
  End Sub

'set values of gadget by its numeric name
  Sub GUIObjVSet(id As Integer,cv As Integer)
    Local Integer n
    n=GUIObjFind(id)
    If n>-1 Then
      Select Case o(1,n,1)
        Case 4,8
          o(1,n,10)=Constrain(cv,o(1,n,7),o(1,n,8))
      End Select
    EndIf
  End Sub

  Function GUIObjVGet(id As Integer)
    Local Integer n
    n=GUIObjFind(id)
    If n>-1 Then
      Select Case o(1,n,1)
        Case 2,3
          GUIObjVGet=o(1,n,2) And 32
        Case 4,8
          GUIObjVGet=o(1,n,10)
      End Select
    EndIf
  End Function

'draws any type of border around an object
  Sub GUIFrame(n As Integer,os As Integer)
    Local Integer c1,c2
    Select Case o(1,n,9) And &h0F
      Case 0'none
        c1=cGy:c2=cGy
      Case 1'button style raised
        c1=&hffffff:c2=0
      Case 2'button style depressed
        c1=0:c2=&hffffff
      Case 3'white
        c1=&hffffff:c2=&hffffff
      Case 4'black
        c1=0:c2=0
      Case 5'grey (disabled)
'        c1=&h999999:c2=&h999999
        c1=cGH:c2=cGH
    End Select
    Colour c1
    Line o(1,n,3)-os+Ut,o(1,n,4)-os+Vt,o(1,n,3)-os+Ut,o(1,n,6)+os+Vt'|
    Line o(1,n,3)-os+Ut,o(1,n,4)-os+Vt,o(1,n,5)+os+Ut,o(1,n,4)-os+Vt'-
    Colour c2
    Line o(1,n,5)+os+Ut,o(1,n,4)-os+Vt,o(1,n,5)+os+Ut,o(1,n,6)+os+Vt'|
    Line o(1,n,3)-os+Ut,o(1,n,6)+os+Vt,o(1,n,5)+os+Vt,o(1,n,6)+os+Vt'_
  End Sub



'removes an object from the screen by its internal reference
  Sub GUIObjCleanup(n,f)
    If f Or (o(1,n,2) And 64) Then
      Box o(1,n,3)-1,o(1,n,4)-1,o(1,n,5)-o(1,n,3)+1,o(1,n,6)-o(1,n,4)+1,,cGy,cGy
    EndIf
    o(1,n,2)=o(1,n,2) And &hBF'clear cleanup flag
  End Sub

'Sets the properties of an object
'Returns -1 if not found
  Function GUIObjPSet(id As Integer,b As Integer) As Integer'id,enabled,visible,touched,Set,cleanup
    Local Integer n
    n=GUIObjFind(id)
    If n>-1 Then
      o(1,n,2)=b:Exit Function
    EndIf
    GUIObjPSet=-1'object not found
  End Function

'Returns the properties of an object by its numeric name
'Returns the properties or -1 if not found
  Function GUIObjPGet(id As Integer) As Integer
    Local Integer n
    n=GUIObjFind(id)
    If n>-1 Then
      GUIObjPGet=o(1,n,2):Exit Function
    EndIf
    GUIObjPGet=-1'object not found
  End Function

'Finds the internal reference for an object from its numeric name
'Returns the object number or -1 if not found
  Function GUIObjFind(id)
    Local Integer n
    For n=0 To P-1
      If o(1,n,0)=id Then GUIObjFind=n:Exit Function'object exists
    Next
    GUIObjFind=-1
  End Function

'force a value within boundaries
  Function Constrain(v As Integer,l As Integer,u As Integer) As Integer
        Constrain=Min(Max(v,l),u)
    End Function
  
'defines an object but doesn't draw anything. returns 0 if all OK.
  Function GUIObjDef(id As Integer,tp As Integer,x As Integer,y As Integer,w As Integer,h As Integer,t$,g As Integer,c As Integer,d As Integer) As Integer
    Local Integer n
    If P>Objs Then GUIObjDef=1:Exit Function'too many objects
    n=GUIObjFind(id)
    If n=-1 Then n=P:P=P+1'define or redefine. P always points to the next free "slot"
    o(1,n,0)=id
    o(1,n,1)=tp
    o(1,n,2)=0
    o(1,n,3)=x
    o(1,n,4)=y
    o(1,n,7)=g
    o(1,n,8)=c
    o(1,n,9)=d
    o(1,n,10)=g
    Ot(n)=t$
    Select Case tp
      Case 1,5,8,9'button,textbox,progress bar,frame
        o(1,n,5)=x+w
        o(1,n,6)=y+h
        if o(1,n,7)+o(1,n,8)=0 then
          o(1,n,7) = cGY
        end if
      Case 2,3'Radio,checkbox
        o(1,n,5)=x+15+FONTWIDTH()*Len(t$)
        o(1,n,6)=y+FONTHEIGHT()
      Case 4'Slider
        if ot(n) = "H" then
          o(1,n,4)=y-4
          o(1,n,5)=x+w
          o(1,n,6)=y+14
        else
          o(1,n,3)=x-4
          o(1,n,5)=x+14
          o(1,n,6)=y+h
        end if          
      Case 6'List Static
      Case 7'List DropDown
    End Select
  End Function  

'compatibility functions
  Function Fontheight() As Integer
    If CMM2 Then
      Fontheight=MM.INFO(FONTHEIGHT)
    Else
      Fontheight=MM.FONTHEIGHT
    EndIf
  End Function

  Function Fontwidth() As Integer
    If CMM2 Then
      Fontwidth=MM.INFO(FONTWIDTH)
    Else
      Fontwidth=MM.FONTWIDTH
    EndIf
  End Function

      
  Sub GetTouch
    If CMM2 Then
      L = FALSE
      Xt = MOUSE(x,mp)
      Yt = MOUSE(y,mp)
      if Xt <> Xo or Yt <> Yo then
        GUI CURSOR Xt,Yt  ' here or main loop
      end if
      Xo = Xt
      Yo = Yt
      Xt=-1
      If Mouse(R,mp) Then Save Image "GUI.bmp",Ut,Vt,Wt,Zt
      If Mouse(L,mp) Then ' left button down
        Xt=mouse(X,mp)
        Yt=mouse(Y,mp)
        L = TRUE
      EndIf
    Else
      Xt=Touch(X)
      Yt=Touch(Y)
    EndIf
  End Sub

sub window wn%,xp%,yp%,wd%,ht%,st%
  if st% then
    Ut = xp%
    Vt = yp%
    Wt = wd%
    Zt = ht%
    blit read wn%,xp%-2,yp%-10,wd%+4,ht%+12
    box xp%,yp%,wd%,ht%,1,0,cGy
  else
    blit write wn%,xp%-2,yp%-10
    blit close wn%
  end if
  
end sub


